# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020

@author: Klaus Reinold
"""


from graphics_and_games_klassen import Rechteck, Figur, Text, Ereignisbehandlung
from random import randint


class KopfSymbol(Figur):
    """
    Symbol für Kopf
    """
    
    def __init__(self, basisgroesse):
        """
        Inititalisierung des Kopfes
        """
        super().__init__()
        self.basisgroesse = basisgroesse
        self.GroesseSetzen(self.basisgroesse)
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "rot")
        self.FigurteilFestlegenEllipse(20,-20,20,40,"hellgruen")
        self.FigurteilFestlegenEllipse(10,-30,20,60,"rot")
        self.FigurteilFestlegenEllipse(-40,-25,40,20,"gelb")
        self.FigurteilFestlegenEllipse(-40,5,40,20,"gelb")
        self.FigurteilFestlegenEllipse(-30,-23,15,10,"schwarz")
        self.FigurteilFestlegenEllipse(-30,9,15,10,"schwarz")   
        self.FigurteilFestlegenDreieck(-50,-50,-35,-35,-40,-35,"schwarz")
        self.FigurteilFestlegenDreieck(-50,50,-35,35,-40,35,"schwarz")
        self.xPos = 0
        self.yPos = 0
        self.winkel = 0


        self.PositionSetzen(self.xPos, self.xPos)

        
    
    def PositionSetzen(self, x, y):
        """
        Setzt die Position des Kopfelements.Der Ursprung liegt links oben
        Fensters, die y-Achse zeigt nach unten.(x /y) bedeutet das
        Kaestchen rechts unterhalb der Gitterlinien.
        -- Parameter x x-Position
        -- Parameter y y-Position
        """
        self.xPos = x
        self.yPos = y
        super().PositionSetzen(self.xPos * self.basisgroesse+self.basisgroesse/2, self.yPos * self.basisgroesse+self.basisgroesse/2)
    
    def XPositionGeben(self):
        """
        gibt die x-Koordinate zurück
        """
        return self.xPos

    def YPositionGeben(self):
        """
        gibt die y-Koordinate zurück
        """
        return self.yPos
    

class RumpfSymbol(Figur):
    """
    Symbol für Rumpf
    """
    
    def __init__(self, basisgroesse):
        """
        Inititalisierung des Rumpfes
        """
        super().__init__()
        self.basisgroesse = basisgroesse
        self.GroesseSetzen(int(self.basisgroesse))
        self.FigurteilFestlegenEllipse(-50,-50,60,100,"hellgruen")
        self.FigurteilFestlegenEllipse(-10,-50,60,100,"gruen")
        self.xPos = 0
        self.yPos = 0
        self.PositionSetzen(self.xPos, self.yPos)

        
    
    def PositionSetzen(self, x, y):
        """
        Setzt die Position des Kopfelements.Der Ursprung liegt links oben
        Fensters, die y-Achse zeigt nach unten.(x /y) bedeutet das
        Kaestchen rechts unterhalb der Gitterlinien.
        -- Parameter x x-Position
        -- Parameter y y-Position
        """
        self.xPos = x
        self.yPos = y
        super().PositionSetzen(self.xPos * self.basisgroesse+self.basisgroesse/2, self.yPos * self.basisgroesse+self.basisgroesse/2)
    
    def XPositionGeben(self):
        """
        gibt die x-Koordinate zurück
        """
        return self.xPos

    def YPositionGeben(self):
        """
        gibt die y-Koordinate zurück
        """
        return self.yPos


class SonderSymbol(Figur):
    """
    Oberklasse für Sondersymbole
    """
    
    def __init__(self, basisgroesse):
        """
        Inititalisierung des Kopfes
        """
        super().__init__()
        self.basisgroesse = basisgroesse
        self.GroesseSetzen(self.basisgroesse)
        self.xPos = 0
        self.yPos = 0
        self.winkel = 0
        self.PositionSetzen(self.xPos, self.xPos)
    
    def PositionSetzen(self, x, y):
        """
        Setzt die Position des Kopfelements.Der Ursprung liegt links oben
        Fensters, die y-Achse zeigt nach unten.(x /y) bedeutet das
        Kaestchen rechts unterhalb der Gitterlinien.
        -- Parameter x x-Position
        -- Parameter y y-Position
        """
        self.xPos = x
        self.yPos = y
        super().PositionSetzen(self.xPos * self.basisgroesse+self.basisgroesse/2, self.yPos * self.basisgroesse+self.basisgroesse/2)
    
    def XPositionGeben(self):
        """
        gibt die x-Koordinate zurück
        """
        return self.xPos

    def YPositionGeben(self):
        """
        gibt die y-Koordinate zurück
        """
        return self.yPos


class MinusSymbol(SonderSymbol):
    """
    Oberklasse für Sondersymbole
    """
    
    def __init__(self, basisgroesse):
        """
        Inititalisierung des Kopfes
        """
        super().__init__(basisgroesse)
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "blau")
        self.FigurteilFestlegenRechteck(-50, -10, 100, 20, "weiss")
               

class PilzSymbol(SonderSymbol):
    """
    Oberklasse für Sondersymbole
    """
    
    def __init__(self, basisgroesse):
        """
        Inititalisierung des Kopfes
        """
        super().__init__(basisgroesse)
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "rot")
        self.FigurteilFestlegenRechteck(-50, 0, 95, 45, "transparent") 
        self.FigurteilFestlegenRechteck(-10, 0, 20, 50, "braun") 
        self.FigurteilFestlegenEllipse(-20, -20, 15, 15, "weiss")
        self.FigurteilFestlegenEllipse(-10, -40, 15, 15, "weiss")
        self.FigurteilFestlegenEllipse(10, -30, 15, 15, "weiss")
        

class ApfelSymbol(SonderSymbol):
    """
    Oberklasse für Sondersymbole
    """
    
    def __init__(self, basisgroesse):
        """
        Inititalisierung des Kopfes
        """
        super().__init__(basisgroesse)
        self.FigurteilFestlegenEllipse(-50, -50, 60, 100, "rot")
        self.FigurteilFestlegenEllipse(-10, -50, 60, 100, "rot")
        self.FigurteilFestlegenRechteck(-10, -50, 20, 20, "braun") 

        
class Schlange:
    """
    verwaltet die Schlange
    """
    
    def __init__(self, x, y, startwinkel, basisgroesse):
        """
        Initialisierung
        -- Parameter x x-Wert der Rasterkoordinaten
        -- Parameter y y-Wert der Rasterkoordinaten
        -- Winkel Startwinkel (0, 90, 180, 270)
        """
        self.kopf = KopfSymbol(basisgroesse)
        self.kopf.WinkelSetzen(startwinkel)
        self.kopf.PositionSetzen(x, y)
        self.winkel = startwinkel
        self.rumpf = []
        for i in range (0, 5):
            self.rumpf.append(RumpfSymbol(basisgroesse))
        if self.winkel==90 or self.winkel == 270:
            for i in range (0, 5):
                self.rumpf[i].Drehen(90)
        self.basisgroesse = basisgroesse
        if startwinkel == 0:
            for i in range (0, 5):
                self.rumpf[len(self.rumpf)-1-i].PositionSetzen(x-i-1, y)
        elif startwinkel == 90:
            for i in range (0, 5):
                self.rumpf[len(self.rumpf)-1-i].PositionSetzen(x, y+1+i)
        elif startwinkel == 180:
            for i in range (0, 5):
                self.rumpf[len(self.rumpf)-1-i].PositionSetzen(x+i+1, y)
        elif startwinkel == 270:
            for i in range (0, 5):
                self.rumpf[len(self.rumpf)-1-i].PositionSetzen(x, y-1-i)
        self.basisgroesse = basisgroesse
        self.zaehler = 0
        
    
    def Bewegen(self, verlaengern):
        """
        Bewegt die Schlange ein Feld in der eingestellten Richtung.
        """
        x = self.kopf.XPositionGeben()
        y = self.kopf.YPositionGeben()
        xalt = x
        yalt = y
        if self.kopf.WinkelGeben() == 0:
            x = x + 1
        elif self.kopf.WinkelGeben() == 90:
            y = y - 1
        elif self.kopf.WinkelGeben() == 180:
            x = x - 1
        elif self.kopf.WinkelGeben() == 270:
            y = y + 1
        
        self.kopf.PositionSetzen(x, y)
        
        if not verlaengern:
            self.rumpf[0].Entfernen()
            del self.rumpf[0]

        self.rumpf.append(RumpfSymbol (self.basisgroesse));
        self.rumpf[len(self.rumpf)-1].PositionSetzen (xalt, yalt);
        
        """
        if self.zaehler < 10:
            self.rumpf[0].Entfernen()
            del self.rumpf[0]
            self.zaehler = self.zaehler+1
        else:
            self.zaehler = 0
        self.rumpf.append(RumpfSymbol(self.basisgroesse))
        if self.winkel==90 or self.winkel == 270:
            self.rumpf[len(self.rumpf)-1].Drehen(90)
        self.rumpf[len(self.rumpf)-1].PositionSetzen(xalt, yalt)
        """
        



    def XPositionGeben(self):
        """
        Gibt die x-Position des Schlangenkopfs zurück.
        -- return x-Position des Schlangenkopfs
        """
        return self.kopf.XPositionGeben()
    
    
    def YPositionGeben(self):
        """
        Gibt die x-Position des Schlangenkopfs zurück.
        -- return x-Position des Schlangenkopfs
        """
        return self.kopf.YPositionGeben()
    
        

    def KopfInRumpf(self):
        """
        Prueft ob der Schlangenkopf auf der Position eines Rumpfsymbols ist, d.h.sich die Schlange selbst gebissen hat.
        return wahr, wenn der Kopf im Rumpf liegt.
        """
        return self.kopf.BeruehrtFarbe("gruen")    
    
    def WinkelSetzen(self, winkel):
        """
        Setzt den Winkel
        """
        self.winkel = winkel
        self.kopf.WinkelSetzen(winkel)
        

    def PunktInRumpf(self, x, y):
        """  
        Prueft ob der angegebe Punkt auf der Position eines Rumpfsymbols ist.
        -- return wahr, wenn der Punkt zu einem Rumpfelement gehört.
        """
        for r in self.rumpf:
            if x == r.XPositionGeben() and y == r.YPositionGeben():  
                return True
        return False

 


class SonderFeld:
    """
    Verwaltet einen allgemeines Sonderfeld.
    """


    def __init__(self, s):
        """
        Speichert die Referenz auf das Spiel.
        -- Parameter s das Spiel, in dem der Apfel erzeut werden soll.
        """    
        self.spiel = s
    
    

    def ZufaelligPositionieren(self):
        """
        Positioniert das Sonderfeld an zufaelliger, freier Stelle.
        """  
        x = self.spiel.XKoordinateZufaelligGeben()
        y = self.spiel.YKoordinateZufaelligGeben()
        
        while not self.spiel.IstFrei(x, y):
            x = self.spiel.XKoordinateZufaelligGeben()
            y = self.spiel.YKoordinateZufaelligGeben()
        self.symbol.PositionSetzen(x, y)
    


    def XPositionGeben(self):
        """
        Gibt die x-Position des Sonderfelds zurück.
        -- return x-Position des Sonderfelds
        """    
        return self.symbol.XPositionGeben()
    
    

    def YPositionGeben(self):
        """
        Gibt die y-Position des Sonderfelds zurück.
        -- return y-Position des Sonderfelds
        """    
        return self.symbol.YPositionGeben()
    
    
    """
    Führt die Aktion des Sonderfelds aus.
    Muss in den Unterklassen überschrieben werden
     """
    def Aktion(self):
        pass
    






class Minus(SonderFeld):
    """
    Verwaltet ein Minuszeichen.
    Das Minuszeichen bremst die Geschwindigkeit der Schlange für 100 Züge.
    """


    def __init__(self, s):
        """
        Legt ein Minussymbol an zufaelliger, freier Stelle an.
        -- Parameter s das Spiel, in dem das Minussymbol erzeut werden soll.
        """   
        super().__init__(s)
        self.symbol = MinusSymbol(s.basisGroesse)
        self.ZufaelligPositionieren()
    
    

    def Aktion(self):
        """
        Führt die Aktion des Minusfelds aus
        """    
        self.spiel.Bremsen()
        self.spiel.Entfernen(self)
        self.symbol.Entfernen()
    





class Pilz(SonderFeld):
    """
    Verwaltet einen Pilz.
    Der Pilz laesst die Schlange 10 Züge lang wachsen.
    """

    def __init__(self, s):
        """
        Legt einen Pilz an zufaelliger, freier Stelle an.
        -- Parameter s das Spiel, in dem der Pilz erzeut werden soll.
        """    
        super().__init__(s)
        self.symbol = PilzSymbol(s.basisGroesse)
        self.ZufaelligPositionieren()
    
    

    def Aktion(self):
        """
        Führt die Aktion des Pilzes aus
        """    
        self.spiel.Sonderwachstum()
        self.ZufaelligPositionieren()
    





class Apfel(SonderFeld):
    """
    Verwaltet einen Apfel.
    Der Apfel gibt einen Bonus von 200 Punkten.
    """


    def __init__(self, s):
        """
        Legt einen Apfel an zufaelliger, freier Stelle an.
        -- Parameter s das Spiel, in dem der Apfel erzeut werden soll.
        """
        super().__init__(s)
        self.symbol = ApfelSymbol(s.basisGroesse)
        self.ZufaelligPositionieren()


    def Aktion(self):
        """
        Führt die Aktion des Apfels aus
        """
        self.spiel.PunkteAendern(200)
        self.ZufaelligPositionieren()


           

class Spiel(Ereignisbehandlung):
    """
    Schafft den Rahmen fuer das Spiel.
    """
    

    def __init__(self):  
        """
        Legt das Spiel an
        """   
        super().__init__()

        r = Rechteck()
        r.FarbeSetzen("grau")
        r.GroesseSetzen(672, 504)
        r.PositionSetzen(0,0)
        self.basisGroesse = 28
        self.anzahlKaestchenBreite = 24
        self.anzahlKaestchenHoehe = 18
        self.zellen = [[None]*self.anzahlKaestchenBreite for i in range (self.anzahlKaestchenHoehe)]
        
        for i in range (0, 18):
            for j in range (0, 24):
                self.zellen[i][j] = Rechteck()
                self.zellen[i][j].FarbeSetzen("hellgelb")
                self.zellen[i][j].PositionSetzen(j*self.basisGroesse, i*self.basisGroesse)
                self.zellen[i][j].GroesseSetzen(self.basisGroesse-1, self.basisGroesse-1)
        
        xStart =  randint(0, 20)
        yStart = randint(0, 17)
        richtung = randint(0, 3)
        
        self.schlange = Schlange(xStart, yStart, richtung*90, self.basisGroesse)
        self.sonderfelder = []
        self.sonderfelder.append(Apfel(self))
        for i in range(1, 6):
            self.sonderfelder.append(Pilz(self))
            self.sonderfelder.append(Minus(self))
        
        self.maxSchritte = 10
        self.aktSchritte = self.maxSchritte
        self.sonderZaehler = 0
        self.bremsZaehler = 0
        
        self.punkte = 0
        self.punkteanzeige = Text()
        self.punkteanzeige.PositionSetzen(700, 30)
        self.punkteanzeige.TextSetzen("Punkte: "+str(self.punkte))
        
        self.sonderanzeige = Text()
        self.sonderanzeige.PositionSetzen(700, 40)
        self.sonderanzeige.TextSetzen("")
        
        self.TaktdauerSetzen(500)
        

    def TasteGedrueckt(self, taste):  
        """
        Reaktion auf Tastaturereignisse
        """ 
        if taste == "s" or taste == "S":
            self.Starten()
        elif taste == "p" or taste == "P":
            self.Anhalten()
        elif taste == "down":
            self.schlange.WinkelSetzen(270)
        elif taste == "left":
            self.schlange.WinkelSetzen(180)
        elif taste == "right":
            self.schlange.WinkelSetzen(0)
        elif taste == "up":
            self.schlange.WinkelSetzen(90)
        


    def AktionAusfuehren(self):  
        """
        Methode, die vom Taktgeber regelmaeßig aufgerufen wird
        """   
        if self.schlange.XPositionGeben()<self.anzahlKaestchenBreite and self.schlange.XPositionGeben()>= 0 and  self.schlange.YPositionGeben()<self.anzahlKaestchenHoehe and self.schlange.YPositionGeben()>= 0 and not self.schlange.KopfInRumpf():
            self.aktSchritte = self.aktSchritte - 1
            if self.aktSchritte <= 0:
                self.schlange.Bewegen(True)
                self.aktSchritte = self.maxSchritte
            elif self.sonderZaehler > 0:
                self.schlange.Bewegen(True)
                self.sonderZaehler = self.sonderZaehler - 1
            else:
                self.schlange.Bewegen(False)
            self.punkte = self.punkte + 1
            if self.bremsZaehler > 0:
                if self.bremsZaehler == 1:
                    self.TaktdauerSetzen(500)
                    self.sonderanzeige.TextSetzen("")
                elif self.bremsZaehler == 10:
                    self.sonderanzeige.TextSetzen("!")
                self.bremsZaehler = self.bremsZaehler - 1
            for s in self.sonderfelder:
                if not s == None and self.schlange.XPositionGeben() == s.XPositionGeben() and self.schlange.YPositionGeben() == s.YPositionGeben():
                    s.Aktion()
            self.punkteanzeige.TextSetzen("Punkte: "+str(self.punkte))
        else:
            self.Anhalten()
            t = Text(textgroesse = 20)
            if self.schlange.KopfInRumpf():  
                t.TextSetzen("Game over - Schlange hat sich selbst gebissen")
            else:
                t.TextSetzen("Game over - Spielfeld verlassen")
                
    def XKoordinateZufaelligGeben(self):
        """
        Liefert eine zufällige X-Koordinate eines Sonderfeldes.
        """
        return randint(0, self.anzahlKaestchenBreite-1)
    
    def YKoordinateZufaelligGeben(self):
        """
        Liefert eine zufällige X-Koordinate eines Sonderfeldes.
        """
        return randint(0, self.anzahlKaestchenHoehe-1)
    

    def IstFrei(self, x, y):
        """    
        Testet, ob eine gegebene Position noch frei ist.
        -- Parameter x x-Koordinate der Position
        -- Parameter y y-Koordinate der Position
        -- return wahr, wenn die gegebene Position weder von der Schlange noch anderen Symbolen belegt ist.
        """
        for s in self.sonderfelder:
            if not (s == None) and s.XPositionGeben() == x and s.YPositionGeben() == y:
                return False
                       
        if self.schlange.XPositionGeben() == x and self.schlange.YPositionGeben() == y:
            return False
        
        if self.schlange.PunktInRumpf(x, y):
            return False
        
        return True
    
    def PunkteAendern(self, delta):
        """
        Ändert die Punkte
        -- Parameter delta Veränderungswert
        """
        self.punkte = self.punkte + delta
    
    def Sonderwachstum(self):
        """
        Startet bzw.verlängert das Sonderwachstum der Schlange.
        """
        self.sonderZaehler = self.sonderZaehler + 10
     
    def Bremsen(self):
        """
        Aktiviert die Verzögerung des Ablaufs.
        """
        self.bremsZaehler = 100
        self.TaktdauerSetzen(1000)
        self.sonderanzeige.TextSetzen("+")
        
    def Entfernen(self, element):
        self.sonderfelder.remove(element)
            
Spiel()
