# -*- coding: utf-8 -*-
"""
Created on Wed Mar  3 17:04:51 2021

@author: Johannes Neumeyer
"""

import tkinter as tk

class Beispiel1:
    """
    Ein einfaches Oberflächenbeispiel
    """

    def __init__(self):
        """
        Legt die Oberflächenelemente an
        """
        # Fenster erstellen
        self.fenster = tk.Tk()
        self.fenster.title("Beispiel 1")
        self.fenster.geometry("800x600")

        # Die Steuerelementvariablen ermöglichen den Datenaustausch zwischen Programm und Oberflächenelementen
        self.ausgabeWert = tk.StringVar()
        self.eingabeWert = tk.StringVar()

        # Anzeigeelement für den Ausgabetext
        self.ausgabeText = tk.Label(self.fenster, textvariable = self.ausgabeWert, fg = "Red", bg = "White" )
        self.ausgabeText.place(x = 30, y = 30, width = 200, height = 30)

        # Anzeigeelement für den Eingabetext
        self.eingabeText = tk.Entry(self.fenster, textvariable = self.eingabeWert)
        self.eingabeText.place(x = 30, y = 60, width = 200, height = 30)

        # Schaltfläche (Button)
        self.uebernehmen = tk.Button(self.fenster, text = "Übernehmen", command = self.TexteingabeUebernehmen)
        self.uebernehmen.place(x = 30, y = 100, width = 200, height = 30)

        # Anzeige des Fensters
        self.fenster.mainloop()

    def TexteingabeUebernehmen(self):
        """
        Übernimmt die Benutzereingabe als Ausgabetext
        """
        self.ausgabeWert.set(self.eingabeWert.get())

class Beispiel2:
    """
    Ein einfaches Oberflächenbeispiel
    """

    def __init__(self):
        """
        Legt die Oberflächenelemente an
        """
        # Fenster erstellen
        self.fenster = tk.Tk()
        self.fenster.title("Beispiel 2")
        self.fenster.geometry("800x600")

        # Die Steuerelementvariablen ermöglichen den Datenaustausch zwischen Programm und Oberflächenelementen
        self.ausgabeWert = tk.StringVar()
        self.eingabeWert = tk.StringVar()

        # Anzeigeelement für den Ausgabetext
        self.ausgabeText = tk.Label(self.fenster, textvariable = self.ausgabeWert, fg = "Red", bg = "White" )
        self.ausgabeText.place(x = 30, y = 30, width = 200, height = 30)

        # Anzeigeelement für den Eingabetext
        self.eingabeText = tk.Entry(self.fenster, textvariable = self.eingabeWert)
        self.eingabeText.place(x = 30, y = 60, width = 200, height = 30)

        # Schaltfläche (Button)
        self.uebernehmen = tk.Button(self.fenster, text = "Übernehmen", command = self.TexteingabeUebernehmen)
        self.uebernehmen.place(x = 30, y = 100, width = 200, height = 30)

        # Anzeigeelement für die Überschrift der Farbwahl
        self.vodergrundText = tk.Label(self.fenster, text = "Auswahl Vordergrundfarbe")
        self.vodergrundText.place(x = 250, y = 30, width = 200, height = 20)

        # Steuerelementvariable für die RadioButtons mit Startwert "Red"
        self.gewaehlterRadioButton = tk.StringVar(value = "Red")

        # Erstellen und Positionieren der Radiobuttons
        self.rb1 = tk.Radiobutton(self.fenster, text = "Schwarz", value = "Black", variable = self.gewaehlterRadioButton, command = self.FarbeUebernehmen)
        self.rb1.place(x = 250, y = 60)
        self.rb2 = tk.Radiobutton(self.fenster, text = "Weiß", value = "White", variable = self.gewaehlterRadioButton, command = self.FarbeUebernehmen)
        self.rb2.place(x = 250, y = 80)
        self.rb3 = tk.Radiobutton(self.fenster, text = "Rot", value = "Red", variable = self.gewaehlterRadioButton, command = self.FarbeUebernehmen)
        self.rb3.place(x = 250, y = 100)
        self.rb4 = tk.Radiobutton(self.fenster, text = "Grün", value = "Green", variable = self.gewaehlterRadioButton, command = self.FarbeUebernehmen)
        self.rb4.place(x = 250, y = 120)
        self.rb5 = tk.Radiobutton(self.fenster, text = "Blau", value = "Blue", variable = self.gewaehlterRadioButton, command = self.FarbeUebernehmen)
        self.rb5.place(x = 250, y = 140)

        # Anzeige des Fensters
        self.fenster.mainloop()

    def TexteingabeUebernehmen(self):
        """
        Übernimmt die Benutzereingabe als Ausgabetext
        """
        self.ausgabeWert.set(self.eingabeWert.get())

    def FarbeUebernehmen(self):
        """
        Setzt die ausgewählte Farbe als Textfarbe im Ausgabelabel
        """
        self.ausgabeText.config(fg = self.gewaehlterRadioButton.get())

#b1 = Beispiel1()
b2 = Beispiel2()
