# -*- coding: utf-8 -*-
"""
Created on Mon Oct 18 22:25:50 2021

@author: Florian Janus
"""

import tkinter

class Rahmen:
    """
    Ein einfaches Oberflächenbeispiel
    """
    
    def __init__(self):
        # Fenster
        self.fenster = tkinter.Tk()
        self.fenster.geometry("800x600")
        self.fenster.title = "Beispiel 1"

        # Anzeigeelement
        self.figur1 = Kreis(self.fenster, x=50, y=50, width=100, height=100)

        # Anzeigeelement
        self.figur2 = Pfeil(self.fenster, x=250, y=50, width=100, height=100)

        self.fenster.mainloop()


class Kreis(tkinter.Canvas):
    """
    Eine einfache, selbst gezeichnete Figur
    """
    def __init__(self, master, x, y, width, height, **kw):
        super(Kreis, self).__init__(master=master, bg="yellow", **kw)
        self.place(x=x, y=y, width=width, height=height)
        self.create_oval(width / 4, height / 4, width * 3 / 4, height * 3 / 4, fill="red")


class Pfeil(tkinter.Canvas):
    """
    Zeichnet einen Pfeil
    """
    def __init__(self, master, x, y, width, height, **kw):
        super(Pfeil, self).__init__(master=master, bg="green", **kw)
        self.place(x=x, y=y, width=width, height=height)
        self.create_polygon([width/10, height/2, width/5, height/5, width/5, height*2/5, width*9/10, height*2/5, width*9/10, height*3/5, width/5, height*3/5, width/5, height*4/5, width/10, height/2], outline="black", fill="yellow")
