# -*- coding: utf-8 -*-
"""
Created on Wed Mar  3 17:04:51 2021

@author: Johannes Neumeyer
"""

import tkinter as tk

class Beispiel1:
    """
    Ein einfaches Oberflächenbeispiel
    """

    def __init__(self):
        """
        Legt die Oberflächenelemente an
        """
        # Fenster erstellen
        self.fenster = tk.Tk()
        self.fenster.title("Beispiel 1")
        self.fenster.geometry("800x600")

        # Die Steuerelementvariablen ermöglichen den Datenaustausch zwischen Programm und Oberflächenelementen
        self.ausgabeWert = tk.StringVar()
        self.eingabeWert = tk.StringVar()

        # Anzeigeelement für den Ausgabetext
        self.ausgabeText = tk.Label(self.fenster, textvariable = self.ausgabeWert, fg = "Red", bg = "White" )
        self.ausgabeText.place(x = 30, y = 30, width = 200, height = 30)

        # Anzeigeelement für den Eingabetext
        self.eingabeText = tk.Entry(self.fenster, textvariable = self.eingabeWert)
        self.eingabeText.place(x = 30, y = 60, width = 200, height = 30)

        # Schaltfläche (Button) zum Übernehmen der Texteingabe
        self.uebernehmen = tk.Button(self.fenster, text = "Übernehmen", command = self.TexteingabeUebernehmen)
        self.uebernehmen.place(x = 30, y = 100, width = 200, height = 30)

        # Schaltfläche (Button) zum Grünsetzen
        self.gruenSetzen = tk.Button(self.fenster, text = "Grün Setzen", command = self.TextfarbeGruenSetzen)
        self.gruenSetzen.place(x = 30, y = 140, width = 200, height = 30)

        # Schaltfläche (Button) zum Rotsetzen
        self.rotSetzen = tk.Button(self.fenster, text = "Rot Setzen", command = self.TextfarbeRotSetzen)
        self.rotSetzen.place(x = 30, y = 180, width = 200, height = 30)

        # Anzeige des Fensters
        self.fenster.mainloop()

    def TexteingabeUebernehmen(self):
        """
        Übernimmt die Benutzereingabe als Ausgabetext
        """
        self.ausgabeWert.set(self.eingabeWert.get())

    def TextfarbeGruenSetzen(self):
        """
        Setzt die Farbe des Ausgabetextes auf Grün
        """
        self.ausgabeText.config(fg = "Green")

    def TextfarbeRotSetzen(self):
        """
        Setzt die Farbe des Ausgabetextes auf Rot
        """
        self.ausgabeText.config(fg = "Red")

class Beispiel2:
    """
    Ein einfaches Oberflächenbeispiel
    """

    def __init__(self):
        """
        Legt die Oberflächenelemente an
        """
        # Fenster erstellen
        self.fenster = tk.Tk()
        self.fenster.title("Beispiel 2")
        self.fenster.geometry("800x600")

        # Die Steuerelementvariablen ermöglichen den Datenaustausch zwischen Programm und Oberflächenelementen
        self.ausgabeWert = tk.StringVar()
        self.eingabeWert = tk.StringVar()

        # Anzeigeelement für den Ausgabetext
        self.ausgabeText = tk.Label(self.fenster, textvariable = self.ausgabeWert, fg = "Red", bg = "White" )
        self.ausgabeText.place(x = 30, y = 30, width = 200, height = 30)

        # Anzeigeelement für den Eingabetext
        self.eingabeText = tk.Entry(self.fenster, textvariable = self.eingabeWert)
        self.eingabeText.place(x = 30, y = 60, width = 200, height = 30)

        # Schaltfläche (Button)
        self.uebernehmen = tk.Button(self.fenster, text = "Übernehmen", command = self.TexteingabeUebernehmen)
        self.uebernehmen.place(x = 30, y = 100, width = 200, height = 30)

        # Anzeigeelement für die Überschrift der Farbwahl
        self.vodergrundText = tk.Label(self.fenster, text = "Auswahl Vordergrundfarbe")
        self.vodergrundText.place(x = 250, y = 30, width = 200, height = 20)

        # Steuerelementvariable für die RadioButtons zur Wahl der Vordergrundfarbe mit Startwert "Red"
        self.gewaehlterRadioButtonFG = tk.StringVar(value = "Red")

        # Erstellen und Positionieren der Radiobuttons
        self.fgSchwarz = tk.Radiobutton(self.fenster, text = "Schwarz", value = "Black", variable = self.gewaehlterRadioButtonFG, command = self.FGFarbeUebernehmen)
        self.fgSchwarz.place(x = 250, y = 60)
        self.fgWeiss = tk.Radiobutton(self.fenster, text = "Weiß", value = "White", variable = self.gewaehlterRadioButtonFG, command = self.FGFarbeUebernehmen, state = tk.DISABLED)
        self.fgWeiss.place(x = 250, y = 80)
        self.fgRot = tk.Radiobutton(self.fenster, text = "Rot", value = "Red", variable = self.gewaehlterRadioButtonFG, command = self.FGFarbeUebernehmen)
        self.fgRot.place(x = 250, y = 100)
        self.fgGruen = tk.Radiobutton(self.fenster, text = "Grün", value = "Green", variable = self.gewaehlterRadioButtonFG, command = self.FGFarbeUebernehmen)
        self.fgGruen.place(x = 250, y = 120)
        self.fgBlau = tk.Radiobutton(self.fenster, text = "Blau", value = "Blue", variable = self.gewaehlterRadioButtonFG, command = self.FGFarbeUebernehmen)
        self.fgBlau.place(x = 250, y = 140)

        # Liste zur Verwaltung der Radiobuttons für die Wahl der Textfarbe
        self.fgButtons = [self.fgSchwarz, self.fgWeiss, self.fgRot, self.fgGruen, self.fgBlau]
        ############
        # Anzeigeelement für die Überschrift der Farbwahl
        self.hintergrundText = tk.Label(self.fenster, text = "Auswahl Hintergrundfarbe")
        self.hintergrundText.place(x = 500, y = 30, width = 200, height = 20)

        # Steuerelementvariable für die RadioButtons zur Wahl der Hintergrundfarbe mit Startwert "White"
        self.gewaehlterRadioButtonBG = tk.StringVar(value = "White")

        # Erstellen und Positionieren der Radiobuttons
        self.bgSchwarz = tk.Radiobutton(self.fenster, text = "Schwarz", value = "Black", variable = self.gewaehlterRadioButtonBG, command = self.BGFarbeUebernehmen)
        self.bgSchwarz.place(x = 500, y = 60)
        self.bgWeiss = tk.Radiobutton(self.fenster, text = "Weiß", value = "White", variable = self.gewaehlterRadioButtonBG, command = self.BGFarbeUebernehmen)
        self.bgWeiss.place(x = 500, y = 80)
        self.bgRot = tk.Radiobutton(self.fenster, text = "Rot", value = "Red", variable = self.gewaehlterRadioButtonBG, command = self.BGFarbeUebernehmen, state = tk.DISABLED)
        self.bgRot.place(x = 500, y = 100)
        self.bgGruen = tk.Radiobutton(self.fenster, text = "Grün", value = "Green", variable = self.gewaehlterRadioButtonBG, command = self.BGFarbeUebernehmen)
        self.bgGruen.place(x = 500, y = 120)
        self.bgBlau = tk.Radiobutton(self.fenster, text = "Blau", value = "Blue", variable = self.gewaehlterRadioButtonBG, command = self.BGFarbeUebernehmen)
        self.bgBlau.place(x = 500, y = 140)

        # Liste zur Verwaltung der Radiobuttons für die Wahl der Hintergrundfarbe
        self.bgButtons = [self.bgSchwarz, self.bgWeiss, self.bgRot, self.bgGruen, self.bgBlau]
        #####################

        # Anzeige des Fensters
        self.fenster.mainloop()

    def TexteingabeUebernehmen(self):
        """
        Übernimmt die Benutzereingabe als Ausgabetext
        """
        self.ausgabeWert.set(self.eingabeWert.get())

    def FGFarbeUebernehmen(self):
        """
        Setzt die ausgewählte Farbe als Textfarbe im Ausgabelabel
        """
        self.ausgabeText.config(fg = self.gewaehlterRadioButtonFG.get())

        for b in self.bgButtons:
            # entspricht die aktuell gesetzte Textfarbe dem Wert des aktuellen Hintergrundfarben-Buttons?
            if self.gewaehlterRadioButtonFG.get() == b.cget("value"):
                # aktuellen Hintergrundfarben-Button deaktivieren
                b.config(state = tk.DISABLED)
            else:
                # alle anderen Hintergrundfarben-Buttons aktivieren
                b.config(state = tk.NORMAL)


    def BGFarbeUebernehmen(self):
        """
        Setzt die ausgewählte Farbe als Hintergrundfarbe im Ausgabelabel
        """
        self.ausgabeText.config(bg = self.gewaehlterRadioButtonBG.get())

        for b in self.fgButtons:
            # entspricht die aktuell gesetzte Hintergrundfarbe dem Wert des aktuellen Textfarben-Buttons?
            if self.gewaehlterRadioButtonBG.get() == b.cget("value"):
                # aktuellen Textfarben-Button deaktivieren
                b.config(state = tk.DISABLED)
            else:
                # alle anderen Textfarben-Buttons aktivieren
                b.config(state = tk.NORMAL)

#b1 = Beispiel1()
b2 = Beispiel2()